#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "SpiceUsr.h"

#define                 FILE_SIZE  128
#define                 WORD_SIZE   48


main(int argc, char *argv[]) {


  SpiceDouble             alt;
  SpiceDouble             lat;
  SpiceDouble             lon;
  SpiceDouble             radius;
  SpiceDouble             spoint[3];
  SpiceDouble             et;
  SpiceDouble             et2;
  SpiceChar               utc[WORD_SIZE];
  
  SpiceDouble             SC_pos_bd[3];
  SpiceDouble             lunar_pos_bd[3];
  SpiceDouble             SC_pos_J2k[3];
  SpiceDouble             lunar_pos_J2k[3];
  SpiceDouble             lt_SC, lt_lunar;
  
  
  //$B;HMQ$9$k(Bkernel$B$N%U%!%$%kL>(B
  SpiceChar   leap[FILE_SIZE]="naif0008.tls";                   //$B$&$k$&IC(B
  SpiceChar   pck[FILE_SIZE]="pck00008.tpc";                    //$B7A>u5Z$S<+E><4%b%G%k(B
  SpiceChar   spk[FILE_SIZE]="de403s.bsp";                      //$B<+A3E7BN(B($B7n!$CO5e(B)$B$N0LCV(B
  SpiceChar   spk2[FILE_SIZE]="hayabusa_20040516-20040531.bsp"; //$BC5::5!$N0LCV(B
  
  //$B7W;;>r7o!J3+;O;~4V!$%?!<%2%C%H!$4QB,<T!K$N@_Dj(B
  SpiceChar   time[WORD_SIZE]="2004-05-17T01:00:00";
  
  //$B;HMQ$9$k(Bkernel$B$NFI$_9~$_!J(Bti2utc$B$H$ON.57$,0c$&$,!$$I$A$i$G$b$h$$!K(B
  furnsh_c ( leap );
  furnsh_c ( pck );
  furnsh_c ( spk );
  furnsh_c ( spk2 );
  
  //$BFbItE*$K$O(BET$B$rMQ$$$k$N$G!$(BUTC$B$N3+;O;~4V$r(BET$B$KJQ49(B
  str2et_c ( time, &et );
  
  //$B3+;O;~4V$+$i#2=54VJ,$r0l;~4V9o$_$G7W;;(B
  for(et2=et;et2< et+24*3600*5;et2=et2+600){
    
    //$B;~4V(Bet2$B$r(BUTC$B$KJQ49$7!$I=<((B
    et2utc_c ( et2, "ISOC", 0, WORD_SIZE, utc );
    printf("%s\t",utc);
    
    spkpos_c ( "MUSES-C", et2,   "J2000",  "NONE", "EARTH", SC_pos_bd,  &lt_SC);
    spkpos_c ( "MOON", et2,   "J2000",  "NONE", "EARTH", lunar_pos_bd,  &lt_lunar);
    spkpos_c ( "MUSES-C", et2,   "IAU_EARTH",  "NONE", "EARTH", SC_pos_J2k,  &lt_SC);
    spkpos_c ( "MOON", et2,   "IAU_EARTH",  "NONE", "EARTH", lunar_pos_J2k,  &lt_lunar);
    
    printf ( "%9.5f\t%9.5f\t%9.5f\t%9.5f\t%9.5f\t%9.5f\t%9.5f\t%9.5f\t%9.5f\t%9.5f\t%9.5f\t%9.5f\t%9.5f\n",
            SC_pos_bd[0], SC_pos_bd[1], SC_pos_bd[2], lunar_pos_bd[0], lunar_pos_bd[1], lunar_pos_bd[2],
            SC_pos_J2k[0], SC_pos_J2k[1], SC_pos_J2k[2], lunar_pos_J2k[0], lunar_pos_J2k[1], lunar_pos_J2k[2],
            lt_SC*clight_c ());
  }
}
